package com.steerinfo.ems.mesemsdieseloil.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.ems.mesemsdieseloil.model.MesEmsDieseloil;
import com.steerinfo.ems.mesemsdieseloil.service.IMesEmsDieseloilService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MesEmsDieseloil RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2020-04-08 04:41
 * 类描述
 * 修订历史：
 * 日期：2020-04-08
 * 作者：generator
 * 参考：
 * 描述：MesEmsDieseloil RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/mesemsdieseloils")
public class MesEmsDieseloilController extends BaseRESTfulController {

    @Autowired
    IMesEmsDieseloilService mesEmsDieseloilService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("mesemsdieseloil:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MesEmsDieseloil> list = mesEmsDieseloilService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("mesemsdieseloil:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MesEmsDieseloil> list = mesEmsDieseloilService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MesEmsDieseloil对象创建")
    @ApiImplicitParam(name = "mesEmsDieseloil", value = "详细实体mesEmsDieseloil", required = true, dataType = "MesEmsDieseloil")
    //@RequiresPermissions("mesemsdieseloil:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MesEmsDieseloil model){
        MesEmsDieseloil mesEmsDieseloil = mesEmsDieseloilService.add(model);
        return success(mesEmsDieseloil);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("mesemsdieseloil:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MesEmsDieseloil mesEmsDieseloil = mesEmsDieseloilService.getById(id);
        return success(mesEmsDieseloil);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的mesEmsDieseloil信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "mesEmsDieseloil", value = "详细实体mesEmsDieseloil", required = true, dataType = "MesEmsDieseloil")
    })
    //@RequiresPermissions("mesemsdieseloil:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MesEmsDieseloil model){
        model.setId(id);
        MesEmsDieseloil mesEmsDieseloil = mesEmsDieseloilService.modify(model);
        return success(mesEmsDieseloil);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("mesemsdieseloil:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> ids = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(ids)) {
			  mesEmsDieseloilService.delete(ids);
    	}
      return success();
    }
    
    @GetMapping("/reCalData")
	public RESTfulResult reCalData(@RequestParam String clock) {
    	if (clock == null || clock.isEmpty()) {
    		return failed(null, "请传入统计月份");
    	}
		mesEmsDieseloilService.reCalData(clock);
		return success();
	}
    
    @GetMapping("/synoil")
	public RESTfulResult synoil() {
		mesEmsDieseloilService.synchronousMesEmsData();
		return success();
	}
}
